unit KWARD_Hook;

interface


uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, Winapi.Imm;

function InstallHook: Boolean; stdcall;
procedure UninstallHook; stdcall;

implementation

uses
  RegData;

const
  //ActiveInputSettings ֘A̒ǉB
  SPI_GETTHREADLOCALINPUTSETTINGS = $104E;
  SPI_SETTHREADLOCALINPUTSETTINGS = $104F;

var
  Unifying: Boolean;
  HostWnd: HWND;
  ImeNotifyMsg: UINT;
  CallWndRetHook,
  GetMessageHook: HHOOK;

procedure InitOption;
var
  Reg: TRegData;
begin
  Reg := TRegData.Create;
  try
    if Reg.OpenKey('Software\ShaggyDog\KanaWard\Option', True) then
    begin
      Unifying := Reg.ReadBoolDef('Unifying', False);
      Reg.CloseKey;
    end;
    if Reg.OpenKey('Software\ShaggyDog\KanaWard\Variable', True) then
    begin
      HostWnd := Reg.ReadIntDef('HostWnd', 0);
      ImeNotifyMsg := Reg.ReadIntDef('ImeNotifyMsg', 0);
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

function GetKeyMode: DWORD;
begin
  if (GetKeyState(VK_KANA) and 1) > 0 then
    Result := IME_CMODE_JAPANESE or IME_CMODE_KATAKANA  //pJ^Ji
  else
    Result := IME_CMODE_ALPHANUMERIC;  //pp
end;

function CallWndRetProc(nCode: Integer; wParam: WPARAM; lParam: PCWPRetStruct): LRESULT; stdcall;
const
  IsThread = True;
  IsSession = False;
var
  FocusWnd: HWND;
  Reg: TRegData;
  OpenStatus: Boolean;
  UnifyConv,
  LocalConv: DWORD;
  SessionInput: BOOL;
  LocalSent: DWORD;
  Imc: HIMC;
begin
  Result := CallNextHookEx(0, nCode, wParam, Winapi.Windows.LPARAM(lParam));
  if nCode = HC_ACTION then
  begin
    case lParam.message of
      WM_ACTIVATE:
        if LOWORD(lParam.wParam) <> WA_INACTIVE then
        begin
          FocusWnd := GetFocus;
          Reg := TRegData.Create;
          try
            if Reg.OpenKeyReadOnly('Software\ShaggyDog\KanaWard\Variable') then
            begin
              OpenStatus := Reg.ReadBoolDef('OpenStatus', False);
              UnifyConv := Reg.ReadIntDef('Conversion', GetKeyMode);
              Reg.CloseKey;
            end
            else
            begin
              OpenStatus := False;
              UnifyConv := GetKeyMode;
            end;
          finally
            Reg.Free;
          end;
          LocalConv := UnifyConv;

          if Unifying then
          begin
            //Win8 ȍ~H
            //̓[hZbVPʂ̏ꍇAImmSetConversionStatus ͓삵ȂB
            //̎ SetInputScope g炵AȂKȓ̓[hɂȂB
            //Ȃ̂ŁA̓[hꎞIɃXbhPʂɕςĐݒB
            if SystemParametersInfo(SPI_GETTHREADLOCALINPUTSETTINGS, 0, @SessionInput, 0) then
              SessionInput := not SessionInput
            else
              SessionInput := False;
            if SessionInput then
              SystemParametersInfo(SPI_SETTHREADLOCALINPUTSETTINGS, 0, Pointer(IsThread), 0);
            try
              Imc := ImmGetContext(FocusWnd);
              try
                if Imc <> 0 then
                begin
                  ImmSetOpenStatus(Imc, OpenStatus);
                  ImmGetConversionStatus(Imc, LocalConv, LocalSent);
                  ImmSetConversionStatus(Imc, UnifyConv, LocalSent);
                end;
              finally
                ImmReleaseContext(FocusWnd, Imc);
              end;
            finally
              if SessionInput then
                SystemParametersInfo(SPI_SETTHREADLOCALINPUTSETTINGS, 0, Pointer(IsSession), 0);
            end;
          end
          else
          begin
            Imc := ImmGetContext(FocusWnd);
            try
              if Imc <> 0 then
              begin
                OpenStatus := ImmGetOpenStatus(Imc);
                ImmGetConversionStatus(Imc, LocalConv, LocalSent);
              end;
            finally
              ImmReleaseContext(FocusWnd, Imc);
            end;
            PostMessage(HostWnd, ImeNotifyMsg, Ord(OpenStatus), LocalConv);
          end;
        end;
      WM_IME_NOTIFY:
        case lParam.wParam of
          IMN_SETOPENSTATUS, IMN_SETCONVERSIONMODE:
          begin
            Imc := ImmGetContext(lParam.hwnd);
            try
              if Imc <> 0 then
              begin
                OpenStatus := ImmGetOpenStatus(Imc);
                ImmGetConversionStatus(Imc, LocalConv, LocalSent);
                PostMessage(HostWnd, ImeNotifyMsg, Ord(OpenStatus), LocalConv);
              end;
            finally
              ImmReleaseContext(lParam.hwnd, Imc);
            end;
          end;
        end;
    end;
  end;
end;

function GetMessageProc(nCode: Integer; wParam: WPARAM; lParam: PMsg): LRESULT; stdcall;
var
  FocusWnd: HWND;
  Imc: HIMC;
  Open: Boolean;
  Conv,
  Sent: DWORD;
begin
  Result := CallNextHookEx(GetMessageHook, nCode, wParam, Winapi.Windows.LPARAM(lParam));
  if (nCode = HC_ACTION) and (wParam = PM_REMOVE) then
  begin
    case lParam.message of
      WM_KEYDOWN:
        if (lParam.lParam shr 31 = 0) and (lParam.lParam shr 30 = 0) then
        begin
          case lParam.wParam of
            VK_CAPITAL, VK_KANA:
            begin
              FocusWnd := GetFocus;
              Imc := ImmGetContext(FocusWnd);
              try
                if Imc <> 0 then
                begin
                  Open := ImmGetOpenStatus(Imc);
                  ImmGetConversionStatus(Imc, Conv, Sent);
                end
                else
                begin
                  Open := False;
                  Conv := GetKeyMode;
                end;
                PostMessage(HostWnd, ImeNotifyMsg, Ord(Open), Conv);
              finally
                ImmReleaseContext(FocusWnd, Imc);
              end;
            end;
          end;
        end;
    end;
  end;
end;

function InstallHook: Boolean; stdcall;
var
  ErrorCode: Integer;
begin
  CallWndRetHook := SetWindowsHookEx(WH_CALLWNDPROCRET, @CallWndRetProc, HInstance, 0);
  Result := CallWndRetHook <> 0;
  if Result then
  begin
    GetMessageHook := SetWindowsHookEx(WH_GETMESSAGE, @GetMessageProc, HInstance, 0);
    Result := GetMessageHook <> 0;
  end;
  if not Result then
  begin
    ErrorCode := GetLastError;
    UninstallHook;
    SetLastError(ErrorCode);
  end;
end;

procedure UninstallHook; stdcall;
begin
  UnhookWindowsHookEx(CallWndRetHook);
  UnhookWindowsHookEx(GetMessageHook);
  SendNotifyMessage(HWND_BROADCAST, WM_NULL, 0, 0);
end;

initialization
  InitOption;

end.
